package eval;

import oops.parser.Goal;

/** Goal class for the sum rule.
    @author Bernd Kuehl, Bernd.Kuehl@informatik.uni-osnabrueck.de
    @author Axel-Tobias Schreiner, axel@informatik.uni-osnabrueck.de
    @author Jan Kraneis, jkraneis@informatik.uni-osnabrueck.de
    @version 1.0
*/
public class sum extends product {

  /** shift method stores the value of the subtree
  */
  public void shift(Goal sender, Object value) {
    if (result == null) {
      result = (Number) value;
      return;
    }
    Number left = result, right = (Number) value;
    switch (op) {
      case '+':
        result = new Double(left.doubleValue() + right.doubleValue());
        break;
      case '-':
        result = new Double(left.doubleValue() - right.doubleValue());
        break;
    }
  }
}
