package tree;

import oops.parser.Goal;
import oops.parser.GoalAdapter;
import oops.parser.Lit;

/** Goal class for the sum rule.
    @author Bernd Kuehl, Bernd.Kuehl@informatik.uni-osnabrueck.de
    @author Axel-Tobias Schreiner, axel@informatik.uni-osnabrueck.de
    @author Jan Kraneis, jkraneis@informatik.uni-osnabrueck.de
    @version 1.0
*/
public class sum extends GoalAdapter {
  /** A tree.build object
  */
  protected build op;
  
  /** shift method stores the value of the subtree
  */
  public void shift (Goal sender, Object node) {
    if (result == null) result = node;
    else result = op.build(result, node);
  }
  
  /** shift method stores the value of the actually recognized Lit
  */
  public void shift(Lit lit, Object node) {
    op = (build) node;
  }
}
